*  Monte Carlo simulation 'X-Fortran-3_G.for'
*  {NZɂt@gɂw˂
*  ʑ̃RgXgюˏowXyNgV~[V
*    {NZ̎Ql
*    GNCÍ⏹F{NZɂsψ̓̌qAV~[V@.
*    {ːZpwG, 54(7), 877-883, (1998).
*
*  'X-Fortran-3_G.for (Fortran 77)' programed by Hideki Kato
*
*  vOŐݒ肵UObh̎dl
*    Grid ratio=8 ( = 1.6/0.2 )
*    h=1.6mm
*    d=0.05mm Pb
*    D=0.2mm  Al
*    40 lines/cm
*
      character*30 FLnameS, FLname
      character*30 Comme(10), Comment
      integer*1 MRH(36,25,21)     ! {NZ̕ No. 1:Air, 2:water, 3:Lung, 4:Bone
      integer*1 MRH_G(3200)       ! Obh̕ No. 5:Pb, 6:Al
      dimension ES(300)           ! ˂wXyNg
      dimension IY(55),X(3)       ! ^
      dimension XVOX(3200),YVOX(25),ZVOX(22)
      dimension XVOX_P(36),YVOX_P(25),ZVOX_P(21),XVOX_G(3200)
      dimension mXmax(3),mYmax(3),mZmax(3)
      dimension Ene(4,110),ATTEN(4,3,110)
      dimension VX(45),VINC(4,45),FA(4,45)
      dimension SFImax(4),VCOHmax(4),VCOH(4,45)
      dimension TAC(6),TA1(4),TA2(4),TA3(4),TA4(4),TA5(4)
      dimension DS(2,200,200)      ! ʑ̃RgXg
      dimension PS(3,300)          ! ˏoXyNg
*
* ---  Constants  ---
*
      Pi=3.141592
      mmd=16384
      dmd=16384.1
*
* ---  ^  ---
*      Ehrhardt JCFGeneration of pseudorandom numbers, Med Phys, 13(2), 240-241, (1986).
* ---    ---
*
      IY(1)=3783                            ! ݒ
      do I=2,55                             !
        IY(I)=mod(2*IY(I-1)+I,mmd)          !
      end do                                !
      J=24                                  !
      K=55                                  !
      do I=1,1000                           !
        IY(K)=mod(IY(K)+IY(J),mmd)          ! ^[`
        J=J-1                               ! LQ
        if(J.eq.0) J=55                     !
        K=K-1                               !
        if(K.eq.0) K=55                     !
      end do                                ! ŏ1000͔j
*
* ---   ̑ݍpfʐ  ---
*      iCCx͖ẍقȂ鐅Ɖ肷j
*
      open(1,file='Water.mix',status='old')
       read(1,20) Comment
       read(1,*) RhoOrg
       read(1,*) NoI
       do I=1,NoI
        read(1,3013)Ene(1,I),ATTEN(1,1,I),ATTEN(1,2,I),ATTEN(1,3,I),
     +              temp,temp
        Ene(1,I)=Ene(1,I)*1000.    ! 1000. : MeV ==> keV
       end do
      close(1)
*
*  `qA񊱏U֐ǂݍ
*
      open(1,file='Water.xfs',status='old')
       do I=1,45
        read(1,3014)VX(I),FA(1,I),VINC(1,I)
       end do
      close(1)
*
      SFImax(1)=VINC(1,45)
*
 3013 format(E9.3,5E10.3)
 3014 format(E10.3,2E12.5)
*
* --- gD̃f[^(ICRU 44) ǂݍ
*
      open(1,file='Bone-ICRU.mix',status='old')
       read(1,20)Comment
       read(1,*) RhoOrg
       read(1,*) NoI
       do I=1,NOI
        read(1,3013)Ene(2,I),ATTEN(2,1,I),ATTEN(2,2,I),ATTEN(2,3,I),
     +              temp,temp
        Ene(2,I)=Ene(2,I)*1000.    ! 1000. : MeV ==> keV
       end do
      close(1)
*
      open(1,file='Bone-ICRU.xfs',status='old')
       do I=1,45
        read(1,3014)VX(I),FA(2,I),VINC(2,I)
       end do
      close(1)
*
      SFImax(2)=VINC(2,45)
*
*  --- Grid \̃f[^Ǎ---
*  --- Pb data reading ---
*
      open(1,file='82_Pb.ele',status='old')
       read(1,20)Comment
       read(1,*)RhoOrg
       read(1,*)NoI
       do I=1,NoI
        read(1,3013)Ene(3,I),ATTEN(3,1,I),
     +              ATTEN(3,2,I),ATTEN(3,3,I),temp,temp
        Ene(3,I)=Ene(3,I)*1000.    ! 1000. : MeV ==> keV
       end do
      close(1)
*
      open(1,file='Pb.xfs',status='old')
       do I=1,45
        read(1,3014)VX(I),FA(3,I),VINC(3,I)
       end do
      close(1)
*
      SFImax(3)=VINC(3,45)
*
*  --- Aluminum data reading ---'
*
      open(1,file='13_Al.ele',status='OLD')
       read(1,20)Comment
       read(1,*)RhoOrg
       read(1,*)NoI
       do I=1,NoI
        read(1,3013)Ene(4,I),ATTEN(4,1,I),
     +              ATTEN(4,2,I),ATTEN(4,3,I),temp,temp
        Ene(4,I)=Ene(4,I)*1000.    ! 1000. : MeV ==> keV
       end do
      close(1)
*
      open(1,file='Al.xfs',status='old')
       do I=1,45
        read(1,3014)VX(I),FA(4,I),VINC(4,I)
       end do
      close(1)
*
      SFImax(4)=VINC(4,45)
*
* --- `qimx֐ FAj𒼐ږ@TvOł`iz֐ VCOHjɕύX ---
*
      do ijk=1,4
*
        total=FA(ijk,1)
        do i=2,45
          total=total+FA(ijk,i)*FA(ijk,i)*VX(i)*(VX(i)-VX(i-1))
          VCOH(ijk,i)=total
        end do
*
        VCOH(ijk,1)=VCOH(ijk,2)
        FBase=VCOH(ijk,1)
        aMax=0.
        do i=1,45
          VCOH(ijk,i)=VCOH(ijk,i)-FBase
          if(VCOH(ijk,i).gt.aMax) aMax=VCOH(ijk,i)
        end do
*
        do i=1,45
          VCOH(ijk,i)=VCOH(ijk,i)/aMax
        end do
*
        VCOHmax(ijk)=VCOH(ijk,45)   ! VCOH ̍ől (= 1.000)
*
      end do
*
* ---  ˂wXyNgf[^ǂݍ ---
*
      open(1,file='B_SPCTL.dat')
         do i=1,9
            read(1,20) Comme(i)        ! ǓdȂǂ̏
         end do
         do i=1,300
            read(1,21) tempE, ES(i)    ! qGlM[AΌqitGXj
         end do
      close(1)
   20 format(A30)
   21 format(F6.1,F9.5)
*
      IIImax=300
      do while(ES(IIImax).le.0.)
        IIImax=IIImax-1
      end do
      IIImax=IIImax+1                  ! őGlM[ No.
*
* ---  t@gAƎ˖AqXg[Ȃǂ̏Ǝˏ  ------
*
      open(1,file='Phantom.dat')
        read(1,*) No_Ph                ! t@g̎ No.
        read(1,*) thick                ! t@ǧ
        read(1,*) FLD_Size             ! Ǝ˖TCY
        read(1,*) No_Grid              ! Obh̗L
        read(1,*) QPP                  ! qXg[
        read(1,20) FLnameS             ! ʕۑt@C
      close(1)
*
      if(No_Ph.eq.1) then                 ! t@g̏ꍇ
          Comme(10)='Water Phantom'
          FLname='Phantom_Water.dat'        ! t@gf[^t@C
          JZmax=4                           ! ỹ{NZ
          JXmax=3                           ! w̃{NZ
        else if(No_Ph.eq.2) then          ! _̔xC萅t@g̏ꍇ
          Comme(10)='Bone-Lung Phantom'
          FLname='Phantom_Bone-Lung.dat'
          JZmax=4
          JXmax=7
        else                              ! ȈՋt@g̏ꍇ
          Comme(10)='Chest Phantom'
          FLname='Phantom_Chest.dat'
          JZmax=21
          JXMax=36
      end if
*
* ---  et@gf[^t@Ct@g\ǂݍ  ---
*
      open(1,file=FLname,status='old')
       read(1,*)JJY      ! x̃{NZ
       read(1,*)WFA      ! Air     0.001293
       read(1,*)WFL      ! Lung    0.25
       read(1,*)WFB      ! bone    1.3
       do JY=1,JJY
         read(1,*)YVOX_P(JY)  ! ex{NZ̒ cm
       end do
*
       do JY=1,JJY
         read(1,*) MDATA_NO      ! x{NZԍiǂݔ΂j
*
         if(No_Ph.ne.3) then     ! t@gȊȌꍇ
           do JZ=1,JZmax
            if(No_Ph.eq.1) then                          ! t@g̏ꍇ
               read(1,33)(MRH(JX,JY,JZ),JX=1,JXmax)      ! e{NZ̕ No.
             else   ! if(No_Ph.eq.2) then                ! _xCt@g̏ꍇ
               read(1,34)(MRH(JX,JY,JZ),JX=1,JXmax)      ! e{NZ̕ No.
            end if
           end do
          else      ! if(No_Ph.eq.3) then                  t@g̏ꍇ
           do JZ=JZmax,1,-1                              ! PA Bez
               read(1,35)(MRH(JX,JY,JZ),JX=1,JXmax)      ! e{NZ̕ No.
           end do
         end if
*
       end do
*
      close(1)
*
   33 format(3I1)
   34 format(7I1)
   35 format(36I1)
*
* --- t@gCe{NZTCY̐ݒ
*
      if(No_Ph.eq.1) then      ! t@g̏ꍇ
*
        XVOX_P(1)=3.0
        XVOX_P(2)=34.0
        XVOX_P(3)=3.0
        CXmax=40.
        mXmax(1)=3
*
        ZVOX_P(I)=0.1
        ZVOX_P(2)=thick-0.2
        ZVOX_P(3)=0.05
        ZVOX_P(4)=0.05
        CZmax=Thick
        mZmax(1)=4
*
        CYmax=40.
        mYmax(1)=3
*
        do JZ=1,4
          ZVOX(JZ)=ZVOX_P(JZ)  ! Œl t@g
        end do
        ZVOX(5)=0.16           ! Œl Obh
*
      end if
*
*
      if(No_Ph.eq.2) then      ! _xC萅t@g̏ꍇ
*
        XVOX_P(1)=3.0
        XVOX_P(2)=6.0
        XVOX_P(3)=6.0
        XVOX_P(4)=10.0
        XVOX_P(5)=6.0
        XVOX_P(6)=6.0
        XVOX_P(7)=3.0
        CXmax=40.
        mXmax(2)=7
*
        ZVOX_P(I)=8.0
        ZVOX_P(2)=4.0
        ZVOX_P(3)=7.95
        ZVOX_P(4)=0.05
        CZmax=20.
        mZmax(2)=4
*
        CYmax=40.
        mYmax(2)=3
*
        do JZ=1,4
          ZVOX(JZ)=ZVOX_P(JZ)   ! Œl
        end do
        ZVOX(5)=0.16            ! Œl
*
      end if
*
*
      if(No_Ph.eq.3) then       ! ȈՋt@g̏ꍇ
*
        do I=1,36
          XVOX_P(I)=1.0
        end do
        XVOX_P(1)=3.0
        XVOX_P(36)=3.0
        CXmax=40.
        mXmax(3)=36
*
        do I=1,19
          ZVOX_P(I)=1.0
        end do
        ZVOX_P(20)=0.95
        ZVOX_P(21)=0.05
        CZmax=20.
        mZmax(3)=21
*
        CYmax=40.
        mYmax(3)=25
*
      do JZ=1,21
        ZVOX(JZ)=ZVOX_P(JZ)    ! Œl
      end do
      ZVOX(22)=0.16            ! Œl
*
      end if
*
*  ---  Obh̐ݒ  ---
*
      do I=1,3199,2
        MRH_G(I)=5            ! Lead (Pb)
        XVOX_G(I)=0.005       !  0.05 mm
      end do
      do I=2,3200,2
        MRH_G(I)=6            ! AluminumiXy[Tj
        XVOX_G(I)=0.020       !  0.2 mm 
      end do
      NXmax_G=3200
      CZmax_G=0.16            ! Obh 1.6 mm 
*                             iObhł㉺̃A~̉e͖ł̂Ƃj
*  ---
*                               œ_Obh̐ݒ͖Ȃ̂
      FFD=10000.              ! ł邾sr[ɋ߂ƂiFFD=100mj
      FieldL=FLD_Size         ! x̏Ǝ˖TCY
      FieldW=FLD_Size         ! w̏Ǝ˖TCYi`j
      Ycenter=20.             ! ŜwW
      Xcenter=20.             !     V    xW
*
* ---  ^Cg\  ---
*
      print *,' '
      print *,'      ******    eJV~[V    ******'
      print *,' '
      print *,'         Rނ̃t@gɂw˂'
      print *,'      t@g̔ΑɎˏoʑ̃RgXg'
      print *,'           сCˏowXyNg߂'
      print *,'              i{NZ@ɂj'
      print *,' '
      print *,'            V~[VI܂'
      print *,'      ̃EBhEł͍̑sȂȂŉ'
      print *,' '
      print *,'        ---  Enter L[ƃX^[g܂ ---'
      read(*,*)
      print *,' '
*
      print *,' '
      print *,' <<< Monte Carlo Simulation >>>'
      call GETTIM(IHR,IMIN,ISEC,I100H)
      write(6,66) IHR,IMIN,ISEC
   66 format(1H ,' Jn =',I2,':',I2,':',I2)
      print *,'    ***  Wait long long time  ***'
*
*****  --------------------------------  *****
* -----  Monte Carlo simulation start  ----- *
*****  --------------------------------  *****
*
      do 1100 III=10,IIImax
*
      PS(3,III)=ES(III)*QPP      ! *16./(FLD_Size**2)
      NQPP=ifix(ES(III)*QPP)
      if(NQPP.le.0) go to 1100
      Em=float(III)*0.5          ! Photon energy [keV]
*
        write(6,68)III,IIImax          ! vZi󋵂\
   68   format(1h ,' * ',I3,' / ',I3,'  ')
*
      do 1000 I=1,NQPP
*
      E0=Em
*
* ---  ˓_W  ---
*
   69 do IJK=1,2                     !
        IY(K)=mod(IY(K)+IY(J),mmd)   ! [`
        X(IJK)=float(IY(K))/dmd      !
        J=J-1                        !
        if(J.eq.0) J=55              !
        K=K-1                        !
        if(K.eq.0) K=55              !
      end do                         !
*
      CX00=FieldW*(X(1)-0.5)
      CX0=Xcenter+CX00*(FFD-CZmax)/FFD
      if((CX0.le.0.).or.(CX0.ge.CXmax)) go to 69
*
      CY00=FieldL*(X(2)-0.5)
      CY0=Ycenter+CY00*(FFD-CZmax)/FFD
      if((CY0.le.0.).or.(CY0.ge.CYmax)) go to 69
*
      CZ0=0.
*
* ---  ˊpx  ---
*
      CXY00=CX00*CX00+CY00*CY00
      if(CXY00.eq.0.) go to 1000       ! AP[X ĎqXg[
      CA2=FFD/sqrt(FFD*FFD+CXY00)                  ! Cos
      SA2=sqrt(CXY00)/sqrt(FFD*FFD+CXY00)          ! Sin
      CB2=CX00/sqrt(CXY00)                         ! Cos
      SB2=CY00/sqrt(CXY00)                         ! Sin
*
      JX=0
      XVOXX=0.
      do while(CX0.gt.XVOXX)
        JX=JX+1
        XVOXX=XVOXX+XVOX_P(JX)
      end do
      NPX1=JX                          ! w̓˃{NZ No.
*
      JY=0
      YVOXX=0.
      do while(CY0.gt.YVOXX)
        JY=JY+1
        YVOXX=YVOXX+YVOX_P(JY)
      end do
      NPY1=JY                          ! x̓˃{NZ No.
*
      NPZ1=1                           ! y̓˃{NZ No.
*
      JJJ=1             ! 1 = ꎟ         2 = U
      inGrid=0          ! 0 = t@g   1 = Obh
*
      do JX=1,36
        XVOX(JX)=XVOX_P(JX)
      end do
      do JY=1,36
        YVOX(JY)=YVOX_P(JY)
      end do
*
      NXmax=mXmax(No_Ph)      ! NXmax_P           ! 36
      NYmax=mYmax(No_Ph)      ! NYmax_P           ! 36
      NZmax=mZmax(No_Ph)      ! NZmax_P           ! 20
*
* --------------------------------------------------------------
*
   70 if(E0.lt.5.) go to 1000         ! cut-off energy = 5 keV
*
      NPX0=NPX1
      NPY0=NPY1
      NPZ0=NPZ1
*
* ---  Photon cross sections, Log-Log interpolation  ---
*
      XE0=Log(E0)
      do jfk=1,4      ! 1:Water(Lung, Air)  2:bone  3:Lead  4:Aluminum
        ka=2
        do while(E0.ge.Ene(jfk,ka))
          ka=ka+1
        end do
        XAT11=Log(ATTEN(jfk,1,ka))
        XAT12=Log(ATTEN(jfk,1,ka-1))
        XAT21=Log(ATTEN(jfk,2,ka))
        XAT22=Log(ATTEN(jfk,2,ka-1))
        XAT31=Log(ATTEN(jfk,3,ka))
        XAT32=Log(ATTEN(jfk,3,ka-1))
        XAT41=Log(Ene(jfk,ka))
        XAT42=Log(Ene(jfk,ka-1))
        df=(XE0-XAT42)/(XAT41-XAT42)
        TA1(jfk)=Exp(XAT12+(XAT11-XAT12)*df)   ! coherent
        TA2(jfk)=Exp(XAT22+(XAT21-XAT22)*df)   ! incoherent
        TA3(jfk)=Exp(XAT32+(XAT31-XAT32)*df)   ! Photo-Electric
      end do
      do jfk=1,4
        TAC(jfk)=TA1(jfk)+TA2(jfk)+TA3(jfk)    ! total
        TA4(jfk)=TA3(jfk)/TAC(jfk)             ! PE/Total
        TA5(jfk)=(TA1(jfk)+TA3(jfk))/TAC(jfk)  !(Coh+PE)/Total
      end do
*
*        ʌW cm^2/g  W cm^-1
      TAC(6)=TAC(4)*2.699        ! Aluminum              A~
      TAC(5)=TAC(3)*11.34        ! Lead                  
      TAC(4)=TAC(2)*1.30         ! bone ( Rho=1.30 )     
      TAC(3)=TAC(1)*0.25         ! lung (Rho=0.25)       
      TAC(2)=TAC(1)              ! tissue(water)         
      TAC(1)=TAC(1)*0.001293     ! air (Rho=0.001293)    
*
* ---  Free Path Length  &  type of interaction  ---
*
  101 do IJK=1,2
        IY(K)=mod(IY(K)+IY(J),mmd)           !
        X(IJK)=float(IY(K))/dmd              !
        J=J-1                                ! 
        if(J.eq.0) J=55                      !
        K=K-1                                !
        if(K.eq.0) K=55                      !
      end do                                 !
      if(X(1).le.0.) go to 101
*
      FPL=-Log(X(1))/TAC(2)       ! (=1.0)łFPL (FPL)
      SA0=SA2
      SB0=SB2
      CA0=CA2
      CB0=CB2
      CXS=CX0
      CYS=CY0
      CZS=CZ0
      CXE=CXS+FPL*SA0*CB0                       ! ̑ݍp_wW
      CYE=CYS+FPL*SA0*SB0                       !      V       x
      CZE=CZS+FPL*CA0                           !      V       y
*
      if((CXS-CXE.eq.0.).or.(CYS-CYE.eq.0.).or  ! ɓȏԂł
     +    .(CZS-CZE.eq.0.)) go to 1000          ! Ĕ΂iAP[Xj
*
* ----------------------------------------------------------------------------------
*                                                     {NZ   
*
*    GNCÍ⏹F{NZɂsψ̓̌qAV~[V@.
*    {ːZpwG, 54(7), 877-883, (1998).
*                                                                                
      AXY=(CYS-CYE)/(CXS-CXE)
      BXY=CYS-AXY*CXS
      AXZ=(CZS-CZE)/(CXS-CXE)
      BXZ=CZS-AXZ*CXS
      AYZ=(CZS-CZE)/(CYS-CYE)
      BYZ=CZS-AYZ*CYS
      NXS=NPX0
      NYS=NPY0
      NZS=NPZ0
***
***
20000 if(inGrid.eq.0) then            ! t@g̏ꍇ
        if((NXS.lt.1).or.(NXS.gt.NXmax).or.(NYS.lt.1).or.
     +    (NYS.gt.NYmax).or.(NZS.lt.1)) then
           kato1=kato1+1
           go to 1000     ! next history
        end if
*
        if(NZS.gt.NZmax) then        ! Grid֓˂ꍇ
           inGrid=1                  !
           do JX=1,3200
             XVOX(JX)=XVOX_G(JX)
           end do
           NXmax=3200
           YVOX(1)=CYmax
           NYmax=1
*
           CZmax=thick+0.16
           NZmax=mZmax(No_Ph)+1
*
           JX=0
           XVOXX=0.
           do while(CXS.gt.XVOXX)
             JX=JX+1
             XVOXX=XVOXX+XVOX(JX)
           end do
           NXS=JX
           NYS=1
           NZS=21
         else                     ! t@gɗ܂Ăꍇ
           MASA=MRH(NXS,NYS,NZS)  ! inGrid=0
        end if
      end if
*
      if(inGrid.eq.1) then        ! Obh̏ꍇ
        if((NXS.lt.1).or.(NXS.gt.NXmax).or.(NYS.lt.1).or.   ! 
     +     (NYS.gt.NYmax).or.(NZS.lt.21)) go to 1000        ! ̃qXg[
        if(NZS.gt.21) then
           go to 3000             ! JE^[
        end if
*
        MASA=MRH_G(NXS)
      end if
*
* ------------------
*
      Rho=TAC(MASA)/TAC(2)
      FPP=FPL/Rho
      CXE=CXS+FPP*SA0*CB0
      CYE=CYS+FPP*SA0*SB0
      CZE=CZS+FPP*CA0
*
      JX=0
      XVOXX=0.
      do while(CXE.gt.XVOXX)
        JX=JX+1
        if(JX.le.NXmax) then
            XVOXX=XVOXX+XVOX(JX)
          else
            XVOXX=1.0E+10
        end if
      end do
      NXE=JX
*
      JY=0
      YVOXX=0.
      do while(CYE.gt.YVOXX)
        JY=JY+1
        if(JY.le.NYmax) then
            YVOXX=YVOXX+YVOX(JY)
          else
            YVOXX=1.0E+10
        end if
      end do
      NYE=JY
*
      JZ=0
      ZVOXX=0.
      do while(CZE.gt.ZVOXX)
        JZ=JZ+1
        if(JZ.le.NZmax) then
            ZVOXX=ZVOXX+ZVOX(JZ)
          else
            ZVOXX=1.0E+10
        end if
      end do
      NZE=JZ
***
***
      if((NXS.eq.NXE).and.(NYS.eq.NYE).and.(NZS.eq.NZE)) go to 29500  ! interaction site
      if((NXS.ne.NXE).and.(NYS.ne.NYE).and.(NZS.ne.NZE)) go to 20100
      if((NXS.eq.NXE).and.(NYS.eq.NYE)) go to 20200
      if((NYS.eq.NYE).and.(NZS.eq.NZE)) go to 20400
      if((NXS.eq.NXE).and.(NZS.eq.NZE)) go to 20300
      if(NXS.eq.NXE) go to 20500
      if(NZS.eq.NZE) go to 20700
      go to 20600                 ! (NYS.eq.NYE)
*
*  in case of (NXSNXE).and.(NYSNYE).and.(NZSNZE)
20100 if(CZE.lt.CZS) go to 20160
      if(CYE.lt.CYS) go to 20150
      if(CXE.lt.CXS) go to 20140
*
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
*
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
*
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
*
      kato=1
*
20105 YL=AXY*XH+BXY
      XL=(YH-BXY)/AXY
      XB=(XH-CXS)*(XH-CXS)+(YL-CYS)*(YL-CYS)
      YB=(XL-CXS)*(XL-CXS)+(YH-CYS)*(YH-CYS)
      if(XB.lt.YB) go to 20120
*
      ZL=AYZ*YH+BYZ
      YL=(ZH-BYZ)/AYZ
      YB=(YH-CYS)*(YH-CYS)+(ZL-CZS)*(ZL-CZS)
      ZB=(YL-CYS)*(YL-CYS)+(ZH-CZS)*(ZH-CZS)
      if(YB.ge.ZB) go to 20110
*
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YH)*(CYS-YH)
     +    +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XL
      CYS=YH
      CZS=ZL
*
      if((kato.eq.3).or.(kato.eq.4).or.(kato.eq.7).OR
     +   .(kato.eq.8)) then
          NYS=NYS-1
          go to 20000
        else
          NYS=NYS+1
          go to 20000
      end if
*
20110 XL=(ZH-BXZ)/AXZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YL)*(CYS-YL)
     +    +(CZS-ZH)*(CZS-ZH))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XL
      CYS=YL
      CZS=ZH
      if(kato.ge.5) then
          NZS=NZS-1
          go to 20000
        else
          NZS=NZS+1
          go to 20000
      end if
*
20120 ZL=AXZ*XH+BXZ
      XL=(ZH-BXZ)/AXZ
      XB=(XH-CXS)*(XH-CXS)+(ZL-CZS)*(ZL-CZS)
      ZB=(XL-CXS)*(XL-CXS)+(ZH-CZS)*(ZH-CZS)
      if(XB.ge.ZB) go to 20130
*
      FPL=FPL-sqrt((CXS-XH)*(CXS-XH)+(CYS-YL)*(CYS-YL)
     +    +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XH
      CYS=YL
      CZS=ZL
      if((kato.eq.2).or.(kato.eq.4).or.(kato.eq.6).OR
     +   .(kato.eq.8)) then
          NXS=NXS-1
          go to 20000
        else
          NXS=NXS+1
          go to 20000
      end if
*
20130 YL=(ZH-BYZ)/AYZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YL)*(CYS-YL)
     +    +(CZS-ZH)*(CZS-ZH))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XL
      CYS=YL
      CZS=ZH
      if(kato.ge.5) then
          NZS=NZS-1
          go to 20000
        else
          NZS=NZS+1
          go to 20000
      end if
*
20140 if(NXS-1.eq.0) go to 20141
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20142
20141 XH=0.
20142 JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=2
      go to 20105
*
20150 if(CXE.ge.CXS) go to 30155
      if(NXS-1.eq.0) go to 30151
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 30152
30151 XH=0.
30152 if(NYS-1.eq.0) go to 30153
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 30154
30153 YH=0.
30154 JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=4
      go to 20105
30155 JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      if(NYS-1.eq.0) go to 30156
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 30157
30156 YH=0.
30157 JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=3
      go to 20105
*
20160 if(CYE.lt.CYS) go to 20165
      if(CXE.ge.CXS) go to 30166
      if(NXS-1.eq.0) go to 30161
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 30162
30161 XH=0.
30162 JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      if(NZS-1.eq.0) go to 30163
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 30164
30163 ZH=0.
30164 kato=6
      go to 20105
30166 JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      if(NZS-1.eq.0) go to 30167
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 30168
30167 ZH=0.
30168 kato=5
      go to 20105
*
20165 if(CXE.ge.CXS) go to 20172
      if(NXS-1.eq.0) go to 20166
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20167
20166 XH=0.
20167 if(NYS-1.eq.0) go to 20168
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20169
20168 YH=0.
20169 if(NZS-1.eq.0) go to 20170
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20171
20170 ZH=0.
20171 kato=8
      go to 20105
20172 JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      if(NYS-1.eq.0) go to 20173
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20174
20173 YH=0.
20174 if(NZS-1.eq.0) go to 20175
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20176
20175 ZH=0.
20176 kato=7
      go to 20105
*
*  in case of (NXSNXE).and.(NYSNYE).and.(NZSNZE)
20200 if(CZE.ge.CZS) go to 20206
      if(NZS-1.eq.0) go to 20201
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20202
20201 ZH=0.
20202 kato=2
      go to 20207
20206 JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=1
*
20207 XL=(ZH-BXZ)/AXZ
      YL=(ZH-BYZ)/AYZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YL)*(CYS-YL)
     +   +(CZS-ZH)*(CZS-ZH))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XL
      CYS=YL
      CZS=ZH
      if(kato.eq.2) then
         NZS=NZS-1
         go to 20000
       else
         NZS=NZS+1
         go to 20000
      end if
*
*  in case of (NXSNXE).and.(NZSNZE).and.(NYSNYE)
20300 if(CYE.lt.CYS) go to 20350
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
         JY=JY+1
         YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      kato=1
20310 XL=(YH-BXY)/AXY
      ZL=AYZ*YH+BYZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YH)*(CYS-YH)
     +        +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
      CXS=XL
      CYS=YH
      CZS=ZL
      if(kato.eq.2) then
           NYS=NYS-1
           go to 20000
         else
           NYS=NYS+1
           go to 20000
      end if
20350 if(NYS-1.eq.0) go to 20351
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20352
20351 YH=0.
20352 kato=2
      go to 20310
*
*  in case of (NYSNYE).and.(NZSNZE).and.(NXSNXE)
20400 if(CXE.lt.CXS) go to 20450
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      kato=1
20410 YL=AXY*XH+BXY
      ZL=AXZ*XH+BXZ
      FPL=FPL-sqrt((CXS-XH)*(CXS-XH)+(CYS-YL)*(CYS-YL)
     +    +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
      CXS=XH
      CYS=YL
      CZS=ZL
      if(kato.eq.2) then
          NXS=NXS-1
          go to 20000
       else
          NXS=NXS+1
          go to 20000
      end if
*
20450 if(NXS-1.eq.0) go to 20451
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20452
20451 XH=0.
20452 kato=2
      go to 20410
*
* in case of (NXSNXE).and.(NYSNYE).and.(NZSNZE)
20500 if(CZE.lt.CZS) go to 20530
      if(CYE.lt.CYS) go to 20520
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=1
*
20505 ZL=AYZ*YH+BYZ
      YL=(ZH-BYZ)/AYZ
      YB=(YH-CYS)*(YH-CYS)+(ZL-CZS)*(ZL-CZS)
      ZB=(YL-CYS)*(YL-CYS)+(ZH-CZS)*(ZH-CZS)
      if(YB.ge.ZB) go to 20510
      XL=(YH-BXY)/AXY
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YH)*(CYS-YH)
     +   +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
      CXS=XL
      CYS=YH
      CZS=ZL
      if((kato.eq.2).or.(kato.eq.4)) then
          NYS=NYS-1
          go to 20000
        else
          NYS=NYS+1
          go to 20000
      end if
*
20510 XL=(ZH-BXZ)/AXZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YL)*(CYS-YL)
     +   +(CZS-ZH)*(CZS-ZH))*Rho
      if(FPL.le.0.) go to 29500
      CXS=XL
      CYS=YL
      CZS=ZH
      if(kato.ge.3) then
          NZS=NZS-1
          go to 20000
        else
          NZS=NZS+1
          go to 20000
      end if
*
20520 if(NYS-1.eq.0) go to 20521
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20522
20521 YH=0.
20522 JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=2
      go to 20505
*
20530 if(CYE.ge.CYS) go to 20536
      if(NYS-1.eq.0) go to 20531
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20532
20531 YH=0.
20532 if(NZS-1.eq.0) go to 20533
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20534
20533 ZH=0.
20534 kato=4
      go to 20505
20536 JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      if(NZS-1.eq.0) go to 20537
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20538
20537 ZH=0.
20538 kato=3
      go to 20505
*
*  in case of (NYSNYE).and.(NZSNZE).and.(NXSNXE)
20600 if(CZE.lt.CZS) go to 20630
      if(CXE.lt.CXS) go to 20620
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=1
20605 ZL=AXZ*XH+BXZ
      XL=(ZH-BXZ)/AXZ
      XB=(XH-CXS)*(XH-CXS)+(ZL-CZS)*(ZL-CZS)
      ZB=(XL-CXS)*(XL-CXS)+(ZH-CZS)*(ZH-CZS)
      if(XB.ge.ZB) go to 20610
      YL=AXY*XH+BXY
      FPL=FPL-sqrt((CXS-XH)*(CXS-XH)+(CYS-YL)*(CYS-YL)
     +   +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XH
      CYS=YL
      CZS=ZL
      if((kato.eq.2).or.(kato.eq.4)) then
          NXS=NXS-1
          go to 20000
        else
          NXS=NXS+1
          go to 20000
      end if
*
20610 YL=(ZH-BYZ)/AYZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YL)*(CYS-YL)
     +   +(CZS-ZH)*(CZS-ZH))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XL
      CYS=YL
      CZS=ZH
      if(kato.ge.3) then
          NZS=NZS-1
          go to 20000
        else
          NZS=NZS+1
          go to 20000
      end if
*
20620 if(NXS-1.eq.0) go to 20621
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20622
20621 XH=0.
20622 JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      kato=2
      go to 20605
*
20630 if(CXE.ge.CXS) go to 20636
      if(NXS-1.eq.0) go to 20631
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20632
20631 XH=0.
20632 if(NZS-1.eq.0) go to 20633
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20634
20633 ZH=0.
20634 kato=4
      go to 20605
20636 JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      if(NZS-1.eq.0) go to 20637
      JZ=0
      ZVOXX=0.
      do while(JZ.ne.NZS-1)
        JZ=JZ+1
        ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      ZH=ZVOXX
      go to 20638
20637 ZH=0.
20638 kato=3
      go to 20605
*
*  in case of (NZSNZE).and.(NXSNXE).and.(NYSNYE)
20700 if(CYE.lt.CYS) go to 20730
      if(CXE.lt.CXS) go to 20720
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      kato=1
20705 XL=(YH-BXY)/AXY
      YL=AXY*XH+BXY
      XB=(XH-CXS)*(XH-CXS)+(YL-CYS)*(YL-CYS)
      YB=(XL-CXS)*(XL-CXS)+(YH-CYS)*(YH-CYS)
      if(XB.ge.YB) go to 20710
      ZL=AXZ*XH+BXZ
      FPL=FPL-sqrt((CXS-XH)*(CXS-XH)+(CYS-YL)*(CYS-YL)
     +   +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
      CXS=XH
      CYS=YL
      CZS=ZL
      if((kato.eq.2).or.(kato.eq.4)) then
          NXS=NXS-1
          go to 20000
       else
          NXS=NXS+1
          go to 20000
      end if
*
20710 ZL=AYZ*YH+BYZ
      FPL=FPL-sqrt((CXS-XL)*(CXS-XL)+(CYS-YH)*(CYS-YH)
     +    +(CZS-ZL)*(CZS-ZL))*Rho
      if(FPL.le.0.) go to 29500
*
      CXS=XL
      CYS=YH
      CZS=ZL
      if(kato.ge.3) then
          NYS=NYS-1
          go to 20000
       else
          NYS=NYS+1
          go to 20000
      end if
*
20720 if(NXS-1.eq.0) go to 20721
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20722
20721 XH=0.
20722 JY=0
      YVOXX=0.
      do while(JY.ne.NYS)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      kato=2
      go to 20705
*
20730 if(CXE.ge.CXS) go to 20736
      if(NXS-1.eq.0) go to 20731
      JX=0
      XVOXX=0.
      do while(JX.ne.NXS-1)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      go to 20732
20731 XH=0.
20732 if(NYS-1.eq.0) go to 20734
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20735
20734 YH=0.
20735 kato=4
      go to 20705
20736 JX=0
      XVOXX=0.
      do while(JX.ne.NXS)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      XH=XVOXX
      if(NYS-1.eq.0) go to 20737
      JY=0
      YVOXX=0.
      do while(JY.ne.NYS-1)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      YH=YVOXX
      go to 20738
20737 YH=0.
20738 kato=3
      go to 20705
*                                                                            
*                                                 {NZ  ܂ 
* ------------------------------------------------------------------------------
*
* ---  ݍp_  ---
*
29500 CX1=CXE
      CY1=CYE
      CZ1=CZE
*
      if(inGrid.eq.0) then
        if((CX1.le.0.).or.(CX1.ge.CXmax).or.(CY1.le.0.).or
     +   .(CY1.ge.CYmax).or.(CZ1.le.0.)) then
           kato2=kato2+1
           go to 1000                  ! ̃qXg[
        end if
      end if
*
      if(inGrid.eq.1) then
        if((CX1.le.0.).or.(CX1.ge.CXmax).or.(CY1.le.0.).or
     +   .(CY1.ge.CYmax).or.(CZ1.le.20.)) then
            kato4=kato4+1              ! (CZ1.le.20.)Phantomɖ߂IƂ
            go to 1000                 ! ̃qXg[
        end if
      end if
*
      CX0=CX1
      CY0=CY1
      CZ0=CZ1
*
      JX=0
      XVOXX=0.
      do while(CX0.gt.XVOXX)
        JX=JX+1
        XVOXX=XVOXX+XVOX(JX)
      end do
      NPX1=JX                         ! ݍp_{NẐwW No.
*
      JY=0
      YVOXX=0.
      do while(CY0.gt.YVOXX)
        JY=JY+1
        YVOXX=YVOXX+YVOX(JY)
      end do
      NPY1=JY                         !
*
      JZ=0
      ZVOXX=0.
      do while(CZ0.gt.ZVOXX)
       JZ=JZ+1
       ZVOXX=ZVOXX+ZVOX(JZ)
      end do
      NPZ1=JZ                         !
*
* --- ݍp̎ ---
*
      if(inGrid.eq.0) then    ! t@g
          MASA=MRH(NPX1,NPY1,NPZ1)
        else                  ! Obh
          MASA=MRH_G(NPX1)
      end if
*
      if(MASA.eq.6) then
          jfk=4                  ! Aluminum
        else if(MASA.eq.5) then
          jfk=3                  ! Pb
        else if(MASA.eq.4) then
          jfk=2                  ! Bone
        else
          jfk=1                  ! Lung,Tissue,Air
      end if
*
      if(X(2).lt.TA4(jfk)) then         ! dʏ
        if(jfk.eq.5)then
            go to 4000                  ! ̏ꍇ̂
          else
            go to 1000                  ! ȊO  w͖  ̃qXg[
        end if
      end if
      if(X(2).lt.TA5(jfk)) go to 150    ! U
*                                       ! ̑  񊱏U
* --- 񊱏U ---
*
      V0=511./E0
      T1=(V0+2.)/(9.*V0+2.)
*
  110 do IJK=1,3                        !
        IY(K)=mod(IY(K)+IY(J),mmd)      !
        X(IJK)=float(IY(K))/dmd         !
        J=J-1                           ! 
        if(J.eq.0) J=55                 !
        K=K-1                           !
        if(K.eq.0) K=55                 !
      end do                            !
*
      if(X(1).gt.T1) then
           TK=(V0+2.)/(V0+2.*(1.-X(2)))
           if(X(3).ge.0.5*((V0-TK*V0+1.)**2+1./TK)) go to 110
         else
           TK=1.+(2./V0)*X(2)
           if(X(3).ge.4.*(1./TK-1./(TK*TK))) go to 110
      end if
      V1=V0*TK
      S1=1.-511./E0*(V1/V0-1.)
      if(S1.eq.0.) then
          A1=Pi*0.5
        else
          if(S1.gt.1.) S1=1.
          A1=aTan(sqrt(1.-S1*S1)/S1)
          if(A1.lt.0.) A1=A1+Pi
      end if
*
* --- incoherent scattering function ɂ̗pEp --- *
*
      SFX=Sin(A1*.5)*E0/12.4
      if(SFX.ge.10.) go to 148
      ka=2
  141 if(SFX.lt.VX(ka)) go to 142
      ka=ka+1
      go to 141
  142 SFI=VINC(jfk,ka-1)+(VINC(jfk,ka)-VINC(jfk,ka-1))/
     +      (VX(ka)-VX(ka-1))*(SFX-VX(ka-1))
*
      IY(K)=mod(IY(K)+IY(J),mmd)            !
      X(1)=float(IY(K))/dmd                 !
      J=J-1                                 ! 
      if(J.eq.0) J=55                       !
      K=K-1                                 !
      if(K.eq.0) K=55                       !
*
      if(X(1).gt.SFI/SFImax(jfk)) go to 110
  148 E1=E0/(1.+E0/511.*(1.-Cos(A1)))       ! UqGlM[
      SA1=Sin(A1)                           ! siniUpxj
      CA1=Cos(A1)                           ! cosiUpxj
*
      go to 240
*
* ---  U  ---
*
  150 E1=E0
*
  149 IY(K)=mod(IY(K)+IY(J),mmd)            !
      X(1)=float(IY(K))/dmd                 ! 
      J=J-1                                 !
      if(J.eq.0) J=55                       !
      K=K-1                                 !
      if(K.eq.0) K=55                       !
*                                           
      X(1)=X(1)*VCOHmax(jfk)
*
      ka=2
      do while(X(1).ge.VCOH(jfk,ka))
        ka=ka+1
      end do
*
      SZ=(VX(ka-1)+(X(1)-VCOH(jfk,ka-1))*(VX(ka)
     +       -VX(ka-1))/(VCOH(jfk,ka)-VCOH(jfk,ka-1)))*12.4/E0
      if(SZ.gt.1.)   go to 149
      CCC=1.-2.*SZ*SZ
*
      IY(K)=mod(IY(K)+IY(J),mmd)
      X(1)=float(IY(K))/dmd
      J=J-1
      if(J.eq.0) J=55
      K=K-1
      if(K.eq.0) K=55
*
      if(2.*X(1).gt.1.+CCC*CCC) go to 149
      CA1=CCC
      if(CA1.gt.1.) CA1=1.
      SA1=sqrt(1.-CA1*CA1)
*
* ---  Upx ƁC ČvZ  ---
*
  240 IY(K)=mod(IY(K)+IY(J),mmd)   !
      X(1)=float(IY(K))/dmd        !
      J=J-1                        !
      if(J.eq.0) J=55              !
      K=K-1                        !
      if(K.eq.0) K=55              !
*
      B1=2.*PI*X(1)                ! Uʊp  2Εm
      CB1=Cos(B1)
      SB1=Sin(B1)
*
      CA2=CA0*CA1+SA0*SA1*CB1      ! cos
      if(CA2.gt.1.) CA2=1.         !
      SA2=sqrt(1.-CA2*CA2)         ! sin
      if(SA2.eq.0.) then           ! AP[X̏ꍇ
         SB2=0.                    ! sin
         CB2=1.                    ! cos
       else
         SB9=SB1*SA1/SA2
         if(SA0.eq.0.) then        ! AP[X̏ꍇ
             SB2=SB1               ! sin
             CB2=-CB1              ! cos
           else
             CB9=(CA1-CA0*CA2)/(SA0*SA2)
             SB2=SB0*CB9+CB0*SB9          ! sin
             CB2=CB0*CB9-SB0*SB9          ! sod
         end if
      end if
*
      E0=E1                               ! UqGlM[
      JJJ=2                               ! UtbO
      go to 70
*
* --- dʏ (̂) ---
*
 4000 if(E0.lt.13.035) go to 1000     ! 13.035 keV = L-absorption edge
*                                       kz[ȉ͓w
      do IJK=1,2                      !
        IY(K)=mod(IY(K)+IY(J),mmd)    !
        X(IJK)=float(IY(K))/dmd       !
        J=J-1                         ! 
        if(J.eq.0) J=55               !
        K=K-1                         !
        if(K.eq.0) K=55               !
      end do                          !
*
      if(E0.lt.88.005) go to 4700     ! 88.005 : keV = K-absorption edge
*
*  --- jw ---
      if(X(1).gt.0.788) go to 4700    ! 0.788 : jkŋNm Fraction due to K-shell
      if(X(2).gt.0.960) go to 1000    ! 0.960 : jkł̌u K-shell fluorescence yield
      IY(K)=mod(IY(K)+IY(J),mmd)
      X(1)=float(IY(K))/dmd
      J=J-1
      if(J.eq.0) J=55
      K=K-1
      if(K.eq.0) K=55
      if(X(1).gt.0.797) then       ! 0.797 : K-alpha   0.203 : K-beta
          E0=85.370                ! K-w energy keV (average)
        else
          E0=74.159                ! K-w energy keV (average)
      end if
      go to 4800
*
*  --- kw ---
 4700 if(X(1).gt.0.35) go to 1000  ! 0.35 : kǩu L-shell fluorescence yield
      E0=10.862                    ! L-III wGlM[ keV
*
* --- w̕ˊpx  ---
*
 4800 do IJK=1,2                     !
        IY(K)=mod(IY(K)+IY(J),mmd)   !
        X(IJK)=float(IY(K))/dmd      !
        J=J-1                        !
        if(J.eq.0) J=55              !
        K=K-1                        !
        if(K.eq.0) K=55              !
      end do                         !
*
      CB2=Cos(2.*PI*X(1))            ! 4ΕmƂ
      SB2=Sin(2.*PI*X(1))            !
      CA2=Cos(2.*PI*X(2))            !
      SA2=Sin(2.*PI*X(2))            !
*
      JJJ=2                          ! UtbO
      go to 70
*
* --- ʑ̃RgXgJE^[ ---    2mm~2mm }gNX
*
 3000 if(CA0.eq.1.) then
          CX9=CXS
          CY9=CYS
        else
          FPL9=(CZmax-CZS)/CA0
          CX9=CXS+FPL9*SA0*CB0
          CY9=CYS+FPL9*SA0*SB0
      end if
*
      KX=ifix(CX9*5.)
      KY=ifix(CY9*5.)
*
      if((KX.le.0).or.(KX.gt.200).or.
     +   (KY.le.0).or.(KY.gt.200)) go to 1000
*
      DS(JJJ,KX,KY)=DS(JJJ,KX,KY)+E0     ! GlM[tGX
*
      mmE=ifix(E0*2.)
      PS(JJJ,mmE)=PS(JJJ,mmE)+1.         ! ˏoqXyNg
*
* ---  Next history  ---
 1000 continue
* ---  Next energy  ---
 1100 continue
*
* ---  Monte Carlo finish  ---
*
      write(6,66) IHR,IMIN,ISEC
      call GETTIM(IHR2,IMIN2,ISEC2,I100H)
      write(6,1110) IHR2,IMIN2,ISEC2
 1110 format(1H ,' I =',I2,':',I2,':',I2)
*
* ---  vZʂt@Cɕۑ  ---
*
      open(1,file=FLnameS)
*
        do i=1,10
          write(1,20) Comme(i)     ! ƎˏȂǂ̏
        end do
        write(1,2020) Thick        ! t@g
        write(1,2021) FLD_Size     ! Ǝ˖TCY
        if(No_Grid.eq.0) then      ! ̃vOł̓ObhiNo_Grid=1j
            write(1,2022)
          else
            write(1,2023)
        end if
*
*    ꎟCUʂ̔ʑ̃RgXgiGlM[tGX̂Qzj
       do JJJ=1,2
         do KY=1,200
           do KXX=1,10
             write(1,2025)(DS(JJJ,KX,KY),KX=KXX*20-19,KXX*20)
           end do
         end do
       end do
*    ˁAˏoiꎟCUʁjqXyNgitGXj
       do i=1,300
         Eii=float(i)*0.5
         write(1,2026) Eii,PS(3,i),PS(1,i),PS(2,i)
       end do
*
      close(1)
*
 2020 format(1h ,'t@g = ',F5.1,' cm')
 2021 format(1h ,'Ǝ˖TCY = ',F5.1,' cm')
 2022 format(1h ,'Obh ()')
 2023 format(1h ,'Obh (L)')
 2025 format(20E11.4)
 2026 format(F6.1,3E11.4)
*  ----------------------
      print *,' '
      print *,'  ---   V~[VI܂  ---'
      print *,'  ---      Enter L[ĉ     ---'
      read(*,*)
      stop
      end
 
